﻿; MC Data Fiddler: 200821
; Author: jmone Thread on Interact: http://yabb.jriver.com/interact/index.php?topic=102906.0

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#SingleInstance ignore
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#MaxMem 4095

;============= Set Vars and Check Runtime Mode ===========================
IniRead, MC_WS, MC Data Fiddler.ini,MC_Settings,MC_WS
IniRead, MC_UserName, MC Data Fiddler.ini,MC_Settings,MC_UserName
IniRead, MC_Password, MC Data Fiddler.ini,MC_Settings,MC_Password
EOLChar = {EOL}
CRChar = {CR}
LFChar = {LF}
TabChar = {TAB}
FileEncoding, UTF-8

;============= Initialise and Setup Menu===========================
if !FileExist("MC Data Fiddler.ini")
  {
  Gui, Add, Text,x10 y10,Setup MC Data Fiddler and Configure MC21 for the First Time:
  Gui, Add, Edit, x40 y30 w130 h20 vMC_WS, 127.0.0.1:52199
  Gui, Add, Text,x180 y30,<--- Enter MCWS Server Address:Port
  Gui, Add, Edit, x40 y60 w130 h20 vMC_UserName, username
  Gui, Add, Text,x180 y60,<--- Enter MCWS Username
  Gui, Add, Edit, x40 y90 w130 h20 vMC_Password, password
  Gui, Add, Text,x180 y90,<--- Enter MCWS Password
  Gui, Add, Button, x40 y120 w130 h20, Test
  gui, add, text, x10 y150 w400 0x10
  Gui, Add, Button, x40 y160 w130 h20, Save
  Gui, Add, Button, x250 y160 w130 h20, Cancel
  Gui, Show,,MC Data Fiddler Installer
  Return
;---------- CheckMC and User Settings ----------------
  ButtonTest:
    Gui, Submit, NoHide
    guiControlGet, UserInput
    Progress, b1 w300, Checking for Media Center at %MC_WS%`n Please Wait
    sleep, 1000
    MC_Call = http://%MC_WS%/MCWS/v1/Authenticate
    GoSub, MCWS
    Progress, off
    If Status = 200 
      MsgBox, All OK!
  Return
;---------- Make INI and Registry Changes ----------------
  ButtonSave:
    Gui, Submit, NoHide
    guiControlGet, UserInput
    IniWrite, %MC_WS%, MC Data Fiddler.ini,MC_Settings,MC_WS
    IniWrite, %MC_UserName%, MC Data Fiddler.ini,MC_Settings,MC_UserName
    IniWrite, %MC_Password%, MC Data Fiddler.ini,MC_Settings,MC_Password
    gosub, Script_End
  }

;============= Main Menu ================================
Gui, Add, Text,x10, These Two Options Create a "Tab Delimited Text" file for editing
Gui, Add, Button, x10 y30 w200 h40 gButtonReadInfo, Export the Library From MC`n (Creates TXT File)
Gui, Add, checkbox, vSelectOnly, Only Include Items Selected in MC
Gui, Add, Button, x220 y30 w200 h40 gButtonOpenMPL, Convert a MC MPL Playlist File`n (Creates TXT File)
Gui, Add, Text,x10 y90 w410 h10 0x10
Gui, Add, Text,x10 y100, These Two Options Update or Import items to MC from a "Tab Delimited Text" file
Gui, Add, Button, x10 y120 w200 h40 gButtonWriteInfo, Update MC Library`n (From TXT File)
Gui, Add, Button, x220 y120 w200 h40 gButtonWriteMPL, Create/Import a MC Playlist File`n (From TXT File)
Gui, Add, Text,x10 y180 w410 h10 0x10
Gui, Add, Button, default x140 y200 w150 h25, Cancel
Gui, Show,,MC Data Fiddler Menu

Return
;============= Process Choice =============
ButtonReadInfo:
  Gui, Submit, Hide
  Progress, b1 w300, Downloading Library to MC_Library_%A_Now%.mpl, Please Wait
  MPLFileName = MC_Library_%A_Now%.mpl
  If SelectOnly
    URLDownloadToFile, http://%MC_UserName%:%MC_Password%@%MC_WS%/MCWS/v1/Files/Current?Action=mpl&ActiveFile=-1&Zone=-1&ZoneType=ID, %MPLFileName%
  Else
    URLDownloadToFile, http://%MC_UserName%:%MC_Password%@%MC_WS%/MCWS/v1/Files/Search?Action=mpl&ActiveFile=-1&Zone=-1&ZoneType=ID, %MPLFileName%

  Progress, Off
  msgbox, 4,, Do you want to now Create a Tab Delimited TXT file?
  IfMsgBox Yes
  {
    OutputFileName = MC_Output_%A_Now%.txt
    FileDelete, %OutputFileName%
    Fileread,result, %MPLFileName%
    gosub, Process_MPL
  }
gosub, Script_End

ButtonOpenMPL:
  FileSelectFile, SelectedFile, 3, , Open a file, *.mpl
  GuiControl,,Select%A_GuiControl%,%SelectedFile%
  If (SelectedFile = "")
    Return
  Progress, b1 w300, Reading MPL File, Please Wait
  SplitPath, SelectedFile,,,,OutputFileName
  OutputFileName = %OutputFileName%.txt
  Filedelete, %OutputFileName%
  Fileread,result, %SelectedFile%
  Gui, Submit, Hide
  gosub, Process_MPL
gosub, Script_End

ButtonWriteInfo:
  FileSelectFile, SelectedFile, 3, , Open a file, *.txt
  GuiControl,,Select%A_GuiControl%,%SelectedFile%
  If (SelectedFile = "")
    Return
  Progress, b1 w300, Reading TXT File, Please Wait
  Fileread,result, %SelectedFile%
  Gui, Submit, Hide
  gosub, Update_MC
gosub, Script_End

ButtonWriteMPL:
  FileSelectFile, SelectedFile, 3, , Open a file, *.txt
  GuiControl,,Select%A_GuiControl%,%SelectedFile%
  If (SelectedFile = "")
    Return
  Progress, b1 w300, Reading TXT File, Please Wait
  Fileread,result, %SelectedFile%
  SplitPath, SelectedFile,,,,OutputFileName
  OutputFileName = %OutputFileName%_%A_Now%.mpl
  FileDelete, %OutputFileName%
  Gui, Submit, Hide
  gosub, Process_TXT

  msgbox, 4,, Do you want to Import this Playlist into MC?
  IfMsgBox Yes
  {
    MC_Call = http://%MC_WS%/MCWS/v1/Library/Import?Path=%A_ScriptDir%\%OutputFileName%
    gosub, MCWS
  }
gosub, Script_End

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++ FUNCTIONS and SUBS ++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;------------ Convert TXT to MPL File --------------------
Process_TXT:
progress, b1 w300, Writing %OutputFileName%, Please Wait
AllToWrite =
MC_Field_Num = 0
Loop, parse, result, `n, `r
{
  numlines++
  If A_Index = 1
    StringSplit, MC_Field_Headers, A_Loopfield, %A_Tab%
}

FileAppend,<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>`n, %OutputFileName%
FileAppend,<MPL Version="2.0" Title="MC Fiddler Import %A_Now%" PathSeparator="\">`n, %OutputFileName%

Loop, parse, result, `n, `r
{
  L_Progress := A_Index/numlines*100
  Progress, %L_Progress%

  If A_Index = 1 ; Skip first header line
    Continue
  If !A_Loopfield
    Continue

  StringSplit, MC_Field_Data, A_Loopfield, %A_Tab%

  AllToWrite = %AllToWrite%<Item>`r`n

  Loop, %MC_Field_Data0%
  {
    tempHeader := MC_Field_Headers%a_index%
    tempData := MC_Field_Data%a_index% 
    AllToWrite = %AllToWrite%<Field Name="%tempHeader%">%tempData%</Field>`r`n
  }
  AllToWrite = %AllToWrite%</Item>`r`n

  If !(Mod(A_Index,10000)) ; wite files in chuncks so to not run out of memory but keep file writes low
  {
    StringReplace, AllToWrite, AllToWrite, %EOLChar%, `r`n, All
    StringReplace, AllToWrite, AllToWrite, %CRChar%, `r, All
    StringReplace, AllToWrite, AllToWrite, %LFChar%, `n, All
    StringReplace, AllToWrite, AllToWrite, %TabChar%, %A_Tab%, All
    FileAppend, %AllToWrite%, %OutputFileName%
    AllToWrite =
  }
}
progress, b1 w300, Preparing TXT File, Please Wait
StringReplace, AllToWrite, AllToWrite, %EOLChar%, `r`n, All
StringReplace, AllToWrite, AllToWrite, %CRChar%, `r, All
StringReplace, AllToWrite, AllToWrite, %LFChar%, `n, All
StringReplace, AllToWrite, AllToWrite, %TabChar%, %A_Tab%, All

FileAppend, %AllToWrite%</MPL>`n, %OutputFileName%
Progress, off
Return

;------------ Convert MPL to TXT File --------------------
Process_MPL:

IfInString, result, %EOLChar%
  msgbox, Warning the Library contains the String %EOLChar% and output may not be correctly processed

progress, b1 w300, Preparing MPL File, Please Wait
StringReplace, result, result, >`r`n, %EOLChar%, All
StringReplace, result, result, `r, %CRChar%, All
StringReplace, result, result, `n, %LFChar%, All
StringReplace, result, result, %A_Tab%, %TabChar%, All
StringReplace, result, result, &amp;, &, All ; this may be a bug in MC
StringReplace, result, result, %EOLChar%, >`r`n, All ; mark real end of line

MC_Field_Num = -1
Loop, parse, result, `r, `n
{
  RegExMatch(A_LoopField,"(?<=Name="")(.*)(?="">)", MC_Field_Name)
  numlines++

  IfNotInString, MC_Field_Header, <%MC_Field_Name%>
  {
    MC_Field_Header = %MC_Field_Header%%A_Tab%<%MC_Field_Name%> ; For checking in in string
    MC_Field_Header2 = %MC_Field_Header2%%A_Tab%%MC_Field_Name% ; No < or > for writting to the file
    MC_Field_Num += 1
    MC_Field_List%MC_Field_Num% := MC_Field_Name
  }
}

FileAppend, %MC_Field_Header2%`n, %OutputFileName%, UTF-16

progress, b1 w300, Writing %OutputFileName%, Please Wait

Loop, parse, result, `r , `n
{
  L_Progress := A_Index/numlines*100
  Progress, %L_Progress%

  IfInString, A_LoopField, <Item>
  {
    Loop, %MC_Field_Num%
      MC_Field_Data%A_Index% = {EmptyField}
  }

  IfInString, A_LoopField, <Field Name="
  {
    RegExMatch(A_LoopField,"(?<=Name="")(.*)(?="">)", MC_Field_Name)
    RegExMatch(A_LoopField,"(?<="">)(.*)(?=</Field)", MC_Value)
    Loop, %MC_Field_Num%
    {
      TempVar := MC_Field_List%A_Index%
      IF (TempVar = MC_Field_Name)
      {
        MC_Field_Data%A_Index% = %MC_Value%
        Break
      }
    }
  }

  IfInString, A_LoopField, </Item>
  {
    DataToWrite =
    LineToWrite =
    Loop, %MC_Field_Num%
    {
       DataToWrite := MC_Field_Data%A_Index%
       LineToWrite = %LineToWrite%%A_Tab%%DataToWrite%
    }
     AllToWrite = %AllToWrite%%LineToWrite%`n
  }
  If !(Mod(A_Index,10000)) ; wite files in chuncks so to not run out of memory but keep file writes low
  {
    StringReplace, AllToWrite, AllToWrite, {EmptyField}, %Tab%, All
    FileAppend, %AllToWrite%, %OutputFileName%
    AllToWrite =
  }
}
StringReplace, AllToWrite, AllToWrite, {EmptyField}, %Tab%, All
FileAppend, %AllToWrite%, %OutputFileName%
Progress, off
Return

;------------ Update MC from TXT File --------------------
Update_MC:

AllToWrite =
MC_Field_Num = 0
Loop, parse, result, `n, `r
{
  numlines++
  If A_Index = 1
    StringSplit, MC_Field_Headers, A_Loopfield, %A_Tab%
}

progress, b1 w300, Updating MC, Please Wait

Loop, parse, result, `n, `r
{
  L_Progress := A_Index/numlines*100
  Progress, %L_Progress%

  If A_Index = 1 ; Skip first header line
    Continue

  StringSplit, MC_Field_Data, A_Loopfield, %A_Tab%

  FieldsToWrite = http://%MC_WS%/MCWS/v1/File/SetInfo?File=&FileType=Key&Field=ZNoField
  DataToWrite = &Value=zNoData

  Loop, %MC_Field_Data0%
  {
    tempField := MC_Field_Headers%a_index%
    tempData := MC_Field_Data%a_index% 

    ; find key
    if tempField = Key
    {
      MC_Key = %tempData%
      Continue
    }
    StringReplace, AllToWrite, AllToWrite, %EOLChar%, `r`n, All
    StringReplace, tempData, tempData, %CRChar%, `r, All
    StringReplace, tempData, tempData, %LFChar%, `n, All
    StringReplace, tempData, tempData, %TabChar%, %A_Tab%, All
    StringReplace, tempData, tempData, ", "", All
    tempData = % UriEncode(tempData)
    FieldsToWrite = %FieldsToWrite%,%tempField%
    DataToWrite = %DataToWrite%,%tempData%
  }
  StringReplace, FieldsToWrite, FieldsToWrite, File=, File=%MC_Key%
  StringReplace, FieldsToWrite, FieldsToWrite, =`,, =
  StringReplace, DataToWrite, DataToWrite, =`,, =
  If MC_Key
  {
    MC_Call = %FieldsToWrite%%DataToWrite%&List=CSV

	StringReplace, MC_Call, MC_Call, `%2c, "`%2c", All ; Escape out Comma
    StringReplace, MC_Call, MC_Call, `%0D, "`%0D", All ; Escape out CR
    StringReplace, MC_Call, MC_Call, `%0A, "`%0A", All ; Escape out LF
    StringReplace, MC_Call, MC_Call, `%0D""`%0A, `%0D`%0A, All ; Remove extra Escape out CR/LF (EOL Char)
    StringReplace, MC_Call, MC_Call, `%09, "`%09", All ; Escape out Tab	
	
    GoSub, MCWS
  }
  MC_Key =
}
Progress, off
Return

;-------------MCWS---------------------------
MCWS:
  WinHTTP := ComObjCreate("WinHTTP.WinHttpRequest.5.1")
  ComObjError(false)
  WinHTTP.Open("GET", MC_Call)
  WinHTTP.SetCredentials(MC_UserName,MC_Password,0)
  WinHTTP.SetRequestHeader("Content-type", "application/x-www-form-urlencoded")
  Body = ""
  WinHTTP.Send(Body)
  Result := WinHTTP.ResponseText
  Status := WinHTTP.Status

  If Status = 200 
    Return
  Else 
    {
    Progress, off
    If !Status
      msgbox, Error - MediaCenter not Found at %MC_WS%
    Else
      If Status = 401
        msgbox, Error 401 Access Denied - Check Username / Password
      Else
        msgbox, Error - %Status%  Processed Failed (see details below)`n%MC_Call%`n%Result%
    }
Return


; ----------URL Encode -------------------------------------------------------------------------------------------------------------
; Thanks to users at - https://autohotkey.com/board/topic/75390-ahk-l-unicode-uri-encode-url-encode-function/
; modified from jackieku's code (http://www.autohotkey.com/forum/post-310959.html#310959)
UriEncode(Uri, Enc = "UTF-8")
{
	StrPutVar(Uri, Var, Enc)
	f := A_FormatInteger
	SetFormat, IntegerFast, H
	Loop
	{
		Code := NumGet(Var, A_Index - 1, "UChar")
		If (!Code)
			Break
		If (Code >= 0x30 && Code <= 0x39 ; 0-9
			|| Code >= 0x41 && Code <= 0x5A ; A-Z
			|| Code >= 0x61 && Code <= 0x7A) ; a-z
			Res .= Chr(Code)
		Else
			Res .= "%" . SubStr(Code + 0x100, -1)
	}
	SetFormat, IntegerFast, %f%
	Return, Res
}

UriDecode(Uri, Enc = "UTF-8")
{
	Pos := 1
	Loop
	{
		Pos := RegExMatch(Uri, "i)(?:%[\da-f]{2})+", Code, Pos++)
		If (Pos = 0)
			Break
		VarSetCapacity(Var, StrLen(Code) // 3, 0)
		StringTrimLeft, Code, Code, 1
		Loop, Parse, Code, `%
			NumPut("0x" . A_LoopField, Var, A_Index - 1, "UChar")
		StringReplace, Uri, Uri, `%%Code%, % StrGet(&Var, Enc), All
	}
	Return, Uri
}

StrPutVar(Str, ByRef Var, Enc = "")
{
	Len := StrPut(Str, Enc) * (Enc = "UTF-16" || Enc = "CP1200" ? 2 : 1)
	VarSetCapacity(Var, Len, 0)
	Return, StrPut(Str, &Var, Enc)
}

;=================== APP END ACTIONS ==========================
ButtonCancel:
GuiClose:
GuiEscape:
Script_End:
Gui, Hide
FileDelete, temp.chapters.txt
Progress, Off
;msgbox Finished
exitapp
